## Appendix E Installing Octave

Here is the procedure for installing Octave from scratch on a Unix system.

- Run the shell script `configure`. This will determine the features your system has (or doesn't have) and create a file named `Makefile` from each of the files named `Makefile.in`.

  Here is a summary of the configure options that are most frequently used when building Octave:

  `--prefix=`prefix
    Install Octave in subdirectories below prefix. The default value of prefix is `/usr/local`.
  `--srcdir=`dir
    Look for Octave sources in the directory dir.
  `--with-f2c`
    Use `f2c` even if a Fortran compiler is available.
  `--with-f77`
    Use `f77` to compile Fortran code. You may also specify the name of the compiler to use as an optional argument. For example, `--with-f77=g77` sets the name of the Fortran compiler to `g77`.
  `--enable-shared`
    Create shared libraries. If you are planning to use `--enable-lite-kernel` or the dynamic loading features, you will probably want to use this option. It will make your `.oct` files much smaller and on some systems it may be necessary to build shared libraries in order to use dynamically linked functions.

    You may also want to build a shared version of `libstdc++`, if your system doesn't already have one. Note that a patch is needed to build shared versions of version 2.7.2 of `libstdc++` on the HP-PA architecture. You can find the patch at ftp://ftp.cygnus.com/pub/g++/libg++-2.7.2-hppa-gcc-fix.

  `--enable-dl`
    Use `dlopen` and friends to make Octave capable of dynamically linking externally compiled functions. This only works on systems that actually have these functions. If you plan on using this feature, you should probably also use `--enable-shared` to reduce the size of your `.oct` files.
  `--enable-shl`
    Use `shl_load` and friends to make Octave capable of dynamically linking externally compiled functions. This only works on systems that actually have these functions (only HP-UX systems). If you plan on using this feature, you should probably also use `--enable-shared` to reduce the size of your `.oct` files.
  `--enable-lite-kernel`
    Compile smaller kernel. This currently requires the dynamic linking functions `dlopen` or `shl_load` and friends so that Octave can load functions at run time that are not loaded at compile time.
  `--without-blas`
    Compile and use the generic BLAS and LAPACK versions included with Octave. By default, configure first looks for BLAS and LAPACK matrix libraries on your system, including optimized BLAS implementations such as the free ATLAS 3.0, as well as vendor-tuned libraries. (The use of an optimized BLAS will generally result in several-times faster matrix operations.) Only use this option if your system has BLAS/LAPACK libraries that cause problems for some reason. You can also use `--with-blas=lib` to specify a particular BLAS library `-llib` that configure doesn't check for automatically.
  `--help`
    Print a summary of the options recognized by the configure script.

  See the file `INSTALL` for more information about the command line options used by configure. That file also contains instructions for compiling in a directory other than where the source is located.

- Run make.

  You will need a recent version of GNU Make. Modifying Octave's makefiles to work with other make programs is probably not worth your time. We recommend you get and compile GNU Make instead.

  For plotting, you will need to have gnuplot installed on your system. Gnuplot is a command-driven interactive function plotting program. Gnuplot is copyrighted, but freely distributable. The `gnu' in gnuplot is a coincidence—it is not related to the GNU project or the FSF in any but the most peripheral sense.

  To compile Octave, you will need a recent version of GNU Make. You will also need `g++` 2.7.2 or later. Version 2.8.0 or `egcs` 1.0.x should work. Later versions may work, but C++ is still evolving, so don't be too surprised if you run into some trouble.

  It is no longer necessary to have `libg++`, but you do need to have the GNU implementation of `libstdc++`. If you are using `g++` 2.7.2, `libstdc++` is distributed along with `libg++`, but for later versions, `libstdc++` is distributed separately. For `egcs`, `libstdc++` is included with the compiler distribution.

  If you plan to modify the parser you will also need GNU `bison` and `flex`. If you modify the documentation, you will need GNU Texinfo, along with the patch for the `makeinfo` program that is distributed with Octave.

  GNU Make, `gcc`, and `libstdc++`, `gnuplot`, `bison`, `flex`, and Texinfo are all available from many anonymous ftp archives. The primary site is ftp.gnu.org, but it is often very busy. A list of sites that mirror the software on ftp.gnu.org is available by anonymous ftp from ftp://ftp.gnu.org/pub/gnu/GNUinfo/FTP.

  If you don't have a Fortran compiler, or if your Fortran compiler doesn't work like the traditional Unix f77, you will need to have the Fortran to C translator `f2c`. You can get `f2c` from any number of anonymous ftp archives. The most recent version of `f2c` is always available from netlib.att.com.

  On an otherwise idle Pentium 133 running Linux, it will take somewhere between 1-1/2 to 3 hours to compile everything, depending on whether you are building shared libraries. You will need about 100 megabytes of disk storage to work with (considerably less if you don't compile with debugging symbols). To do that, use the command

                make CFLAGS=-O CXXFLAGS=-O LDFLAGS=

  instead of just ``make`'.

- If you encounter errors while compiling Octave, first check the list of known problems below to see if there is a workaround or solution for your problem. If not, see Trouble, for information about how to report bugs.
- Once you have successfully compiled Octave, run ``make install`'.

  This will install a copy of octave, its libraries, and its documentation in the destination directory. As distributed, Octave is installed in the following directories. In the table below, prefix defaults to `/usr/local`, version stands for the current version number of the interpreter, and arch is the type of computer on which Octave is installed (for example, ``i586-unknown-gnu`').

  `prefix/bin`
    Octave and other binaries that people will want to run directly.
  `prefix/lib`
    Libraries like libcruft.a and liboctave.a.
  `prefix/share`
    Architecture-independent data files.
  `prefix/include/octave`
    Include files distributed with Octave.
  `prefix/man/man1`
    Unix-style man pages describing Octave.
  `prefix/info`
    Info files describing Octave.
  `prefix/share/octave/version/m`
    Function files distributed with Octave. This includes the Octave version, so that multiple versions of Octave may be installed at the same time.
  `prefix/lib/octave/version/exec/arch`
    Executables to be run by Octave rather than the user.
  `prefix/lib/octave/version/oct/arch`
    Object files that will be dynamically loaded.
  `prefix/share/octave/version/imagelib`
    Image files that are distributed with Octave.